package edu.uoc.pfc.mena.db.core.connection;

import java.sql.Driver;
import java.sql.DriverManager;
import java.sql.SQLException;

import edu.uoc.pfc.mena.db.core.constants.Constants;
import edu.uoc.pfc.mena.db.core.exception.BDException;

public class ConnexioImpl implements Connexio {
	
	private String usuari=null;
	private String contrasenya=null;
	private String nomControlador=null;
	private String url;
	private Driver controlador=null;
	private String idControlador;
	
	
	public ConnexioImpl(String url, String usuari, String contrasenya, String nomControlador, String idControlador) throws BDException {
		super();
		this.url=url;
		this.usuari=usuari;
		this.contrasenya=contrasenya;
		this.nomControlador=nomControlador;
		this.idControlador=idControlador;
		init();
	}
	
	private void init() throws BDException {		
		
		try {
			controlador = (Driver) Class.forName(nomControlador).newInstance();
		} catch (InstantiationException e) {
			throw new BDException (Constants.INIT_CONNECTION_INSTANCE_ERROR_CODE, Constants.INIT_CONNECTION_ERROR_MSG + e.getMessage(), e);
		} catch (IllegalAccessException e) {
			throw new BDException (Constants.INIT_CONNECTION_INSTANCE_ERROR_CODE, Constants.INIT_CONNECTION_ERROR_MSG + e.getMessage(), e);
		} catch (ClassNotFoundException e) {
			throw new BDException (Constants.INIT_CONNECTION_INSTANCE_ERROR_CODE, Constants.INIT_CONNECTION_ERROR_MSG + e.getMessage(), e);
		}
		try {
			DriverManager.registerDriver(controlador);
		} catch (SQLException e) {
			throw new BDException (Constants.INIT_CONNECTION_REGISTER_DRIVER_CODE, Constants.INIT_CONNECTION_REGISTER_DRIVER_MSG + e.getMessage(), e);
		}
	}
	

	public String getUsuari() {
		return usuari;
	}

	public void setUsuari(String usuari) {
		this.usuari = usuari;
	}

	public String getContrasenya() {
		return contrasenya;
	}

	public void setContrasenya(String contrasenya) {
		this.contrasenya = contrasenya;
	}

	public String getNomControlador() {
		return nomControlador;
	}

	public void setNomControlador(String nomControlador) {
		this.nomControlador = nomControlador;
	}

	public String getIdControlador() {
		return idControlador.toUpperCase();
	}

	public void setIdControlador(String idControlador) {
		this.idControlador = idControlador;
	}

	public String getUrl() {
		return url;
	}

	public void setUrl(String url) {
		this.url = url;
	}

	public Driver getControlador() {
		return controlador;
	}

	public void setControlador(Driver controlador) {
		this.controlador = controlador;
	}
	
}
