package edu.uoc.pfc.mena.db.core.connection.factory;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

import edu.uoc.pfc.mena.db.core.config.ConfiguradorFactory;
import edu.uoc.pfc.mena.db.core.connection.Connexio;
import edu.uoc.pfc.mena.db.core.connection.ConnexioImpl;
import edu.uoc.pfc.mena.db.core.constants.Constants;
import edu.uoc.pfc.mena.db.core.exception.BDException;


public class ConnexioFactory {

	 private static ConnexioFactory instance;
	 private Connexio con= null;
	 
	 private ConnexioFactory(){
		 super();
	 }
	 
	 public static synchronized ConnexioFactory getInstance() throws BDException {
		  
		    if( instance == null ){
		    	instance = new ConnexioFactory();
		      
		    	// omplim els camps amb la info del CONFIG_FILE
				String usuari=ConfiguradorFactory.getInstance().getUsuariBD(); // getUsuariFromConfigFile
				String contrasenya=ConfiguradorFactory.getInstance().getContrasenyaBD(); // getContrasenyaFromConfigFile
				String url=ConfiguradorFactory.getInstance().getUrlBD(); // getURLFromConfigFile
				String controlador=ConfiguradorFactory.getInstance().getDriverBD();
				String idControlador=ConfiguradorFactory.getInstance().getIdDriverBD();
				instance.con= new ConnexioImpl(url, usuari, contrasenya, controlador, idControlador);
		    }
		    
		    return instance;
	}
	 
	
	 public Connexio getConnexio() {
		return con;
	}

	public void setConnexio(Connexio con) {
		this.con = con;
	}

	public Connection creaConnexio() throws BDException {
		 try {
			 return DriverManager.getConnection(con.getUrl(), con.getUsuari(), con.getContrasenya());
		 }catch (SQLException e){
			 throw new BDException(Constants.GET_CONNECTION_ERROR_CODE, Constants.GET_CONNECTION_ERROR_MSG, e);
		 }
	 }
}
