package edu.uoc.pfc.mena.db.core.constants;

public interface Constants {

	//Configuracio BD
	public static final String CONFIG_FILE = "uoc-bd-config.properties";
	
	// Dades del fitxer
	public static final String URL_BD = "bd.connection.url";
	public static final String USER_BD = "bd.connection.user";
	public static final String PASS_BD = "bd.connection.pass";
	public static final String DRIVER_BD = "bd.connection.driver";
	public static final String ID_DRIVER_BD = "bd.connection.driver.id";
	public static final String PKG_BDBEANS = "bd.beans.package";
	public static final String BASEDIR_BDBEANS = "bd.beans.basedir";
	
	public static final String PREFIX_PACKAGE_GENERATOR ="bd.connection.bdbeans.prefix.package";
	public static final String PREFIX_CLASS_GENERATOR ="bd.connection.bdbeans.prefix.class";
	public static final String SUFIX_CLASS_GENERATOR ="bd.connection.bdbeans.sufix.class";
	
	
	// SQLUtils
	public static final String ORACLE_ID_AUTO_INCREMENTAL ="$$ID$$";
	public static final String ORACLE_TEXT="oracle";
	public static final String MYSQL_TEXT="mysql";
	public static final String HSQLDB_TEXT="hsqldb";
	
	public static final String INSERT_PREFIX_TEXT="INSERT INTO ";
	public static final String UPDATE_PREFIX_TEXT = "UPDATE ";
	public static final String DELETE_PREFIX_TEXT = "DELETE FROM ";
	public static final String SELECT_PREFIX_TEXT = "SELECT * FROM ";
	public static final String WHERE_TEXT= " WHERE ";
	public static final String SET_TEXT=" SET ";
	public static final String VALUES_TEXT=" ) VALUES (";
	public static final String COMMA=",";
	public static final String EQUALS="=";
	public static final String PARENTESIS_OPEN ="(";
	public static final String PARENTESIS_CLOSE=")";
	
	// Errors
	public static final int GET_CONNECTION_ERROR_CODE=1;
	public static final String GET_CONNECTION_ERROR_MSG="No s'ha pogut connectar amb la base de dades.";
	
	public static final int REGISTRE_NULL_OBJECT_ERROR_CODE=2;
	public static final String REGISTRE_NULL_OBJECT_ERROR_MSG="No es poden obtenir les metadades d'un bean buit.";
	
	public static final int REGISTRE_NO_ENTITAT_ANNOTATION_ERROR_CODE=3;
	public static final String REGISTRE_NO_ENTITAT_ANNOTATION_ERROR_MSG="No es podent obtenir les metadades d'un objecte que no sigui una entitat (Annotacio Entitat no deficida).";
	
	public static final int TRANSACTION_ERROR_CODE=4;
	public static final String TRANSACTION_ERROR_MSG="No s'ha pogut crear una nova trasaccio : ";
	
	public static final int TYPE_MAPPING_ERROR_CODE=5;
	
	public static final int METHOD_MAPPING_ERROR_CODE=6;
	public static final int ARGUMENT_MAPPING_ERROR_CODE=7;
	public static final int ACCES_MAPPING_ERROR_CODE=8;
	public static final int INVOCATION_MAPPING_ERROR_CODE=9;
	public static final int SECURITY_MAPPING_ERROR_CODE=10;

	
	public static final String MAPPING_ERROR_MSG="No s'ha pogut relitzar el mapping amb la base de dades correctament : ";
	
	public static final int TRANSACTION_CONNECTION_ERROR_CODE=11;
	public static final String  TRANSACTION_CONNECTION_ERROR_MSG="No s'ha pogut obtenir una nova connexi de la base de dades.";
	
	
	public static final int NULL_CONNECTION_ERROR_CODE=12;
	public static final String NULL_CONNECTION_ERROR_MSG="La connexi s null, no es pot realitzar la operaci ";
	public static final int COMMIT_ERROR_CODE=13;
	public static final String COMMIT_ERROR_MSG="Error realitzant el commit de la connexi  : ";
	public static final int ROLLBACK_ERROR_CODE=14;
	public static final String ROLLBACK_ERROR_MSG="Error realitzant el rollback de la connexi : ";
	
	public static final int CLOSE_ERROR_CODE=15;
	public static final String CLOSE_ERROR_MSG="Error realitzant el tancament de la connexi : ";
	
	public static final int EXECUTING_UPDATE_ERROR_CODE=16;
	public static final String EXECUTING_UPDATE_ERROR_MSG="Error realitzant la operaci a la base de dades : ";
	
	public static final int EXECUTING_UPDATE_MULTIPLE_REGISTRES_ERROR_CODE=17;
	public static final String EXECUTING_UPDATE_MULTIPLE_REGISTRES_ERROR_MSG="L'execuci de la operaci no noms modifica un nic registre";
	
	public static final int EXECUTING_QUERY_ERROR_CODE=18;
	public static final String EXECUTING_QUERY_ERROR_MSG="Error realitzant la consulta a la base de dades : ";
	
	public static final int EXECUTING_QUERY_COUNT_ERROR_CODE=19;
	public static final String EXECUTING_QUERY_COUNT_ERROR_MSG="Error realitzant el 'count' a la base de dades : ";
	
	public static final int GENERADOR_BEANS_ERROR_CODE=20;
	public static final String GENERADOR_BEANS_ERROR_MSG="Error realitzant la generaci dels beans a partir de l'esquema de base de dades : ";
	
	public static final int TABLE_MAPPING_ERROR_CODE=21;
	public static final String TABLE_MAPPING_ERROR_MSG="El nom de la taules no coincideix amb el resultat del resultset ";
	
	public static final int CONFIGURATION_FILE_ERROR_CODE=22;
	public static final String CONFIGURATION_FILE_ERROR_MSG="No es troba el fitxer de configuraci 'uoc-bd-config.properties'";
	
	public static final int INIT_CONNECTION_INSTANCE_ERROR_CODE=23;
	public static final int INIT_CONNECTION_ACCES_ERROR_CODE=24;
	public static final int INIT_CONNECTION_CLASSNOTFOUND_ERROR_CODE=25;
	public static final String INIT_CONNECTION_ERROR_MSG="No s'ha pogut inicialitzar el driver de connexi a la base de dades : ";
	
	public static final int INIT_CONNECTION_REGISTER_DRIVER_CODE=26;
	public static final String INIT_CONNECTION_REGISTER_DRIVER_MSG="No s'ha pogut registrar el driver de connexi a la base de dades : ";
	
	public static final int SQL_MAPPING_ERROR_CODE=27;
	public static final int INSTANTATION_MAPPING_ERROR_CODE=28;
	
	public static final int ANNOTATION_CLASS_MAPPING_ERROR_CODE=29;
	public static final String ANNOTATION_CLASS_MAPPING_ERROR_MSG="No es pot fer el mapping si la classe no disposa de l'annotacio @Entitat o @Mapper";
	
	public static final int PK_ERROR_CODE=30;
	public static final String UNDEFINED_PK_ERROR_MSG="No esta definida la clau primaria";
	public static final String PK_ERROR_MSG="Error obtenint la clau primaria : ";
	
	public static final int GET_METADATA_ERROR_CODE=31;
	public static final String GET_METADATA_ERROR_MSG="Error obtenint les metadades de la taula : ";
	
}
