package edu.uoc.pfc.mena.db.core.session.factory;

import edu.uoc.pfc.mena.db.core.exception.BDException;
import edu.uoc.pfc.mena.db.core.session.Sessio;
import edu.uoc.pfc.mena.db.core.session.SessioImpl;

public class SessioFactory {

	 private static SessioFactory instance;

	 private SessioFactory(){
		 super(); 
	 }
	 
	 public static synchronized SessioFactory getInstance() {
		    if( instance == null ){
		    	instance = new SessioFactory();
		    }
		    
		    return instance;
	}
	 
	 public Sessio newSessio() throws BDException {
		 return new SessioImpl();
	 }
}
