package edu.uoc.pfc.mena.db.utilities;

import java.sql.ResultSet;
import java.util.logging.Logger;

public class GeneradorColumnaBDInfoImpl implements GeneradorColumnaBDInfo, GeneradorConstants{

	private static Logger log = Logger.getLogger(GeneradorColumnaBDInfoImpl.class.getName());
	
	  private int tipus;
	  private int precisio;
	  private int tamany;
	  private String nom;
	  private boolean nullable;
	  private boolean autoincremental;
	  private String nomTipus;
	  
	 
	  
	  public String getNom()
	  {
	    return this.nom;
	  }
	  
	  public int getPrecisio(){
		  return this.precisio;
	  }

	  public int getTamany() {
		return tamany;
	}

	public void setTamany(int tamany) {
		this.tamany = tamany;
	}

	public boolean isNullable() {
		return nullable;
	}

	public void setNullable(boolean nullable) {
		this.nullable = nullable;
	}

	public boolean isAutoincremental() {
		return autoincremental;
	}

	public void setAutoincremental(boolean autoincremental) {
		this.autoincremental = autoincremental;
	}

	public String getNomTipus() {
		return nomTipus;
	}

	public void setNomTipus(String nomTipus) {
		this.nomTipus = nomTipus;
	}

	public void setTipus(int tipus) {
		this.tipus = tipus;
	}
	
	public void setPrecisio(int precisio) {
		this.precisio = precisio;
	}

	public void setNom(String nom) {
		this.nom = nom;
	}

	public GeneradorColumnaBDInfoImpl(){}
	  
	 

	  public int getTipus() {
		  return this.tipus;
	  }
//	  public String getTipus() {
//	    if ((this.tipus > sqlTypes.length) || (this.tipus < 0)) {
//	      return ""+this.tipus;
//	    }
//	    return sqlTypes[(this.tipus - 1)];
//	  }
	  
	  public String toString()
	  {
	    return "ColumnaBDInfo : [nom="+this.getNom()+"], [nomTipus="+this.getNomTipus()+"], [tipus="+this.getTipus()+"], [tamany="+this.getTamany()+"], [precision="+this.getPrecisio()+"], [isAutoincremental="+this.isAutoincremental()+"], [isNullable="+this.isNullable()+"], [tipusJava="+this.getTipusJava()+"]";
	  }
	  
	  /*public String toString()
	  {
	    String res = "";
	    String digits = "";

	    if ((this.tipus == 1) || (this.tipus == 11))
	      digits = "(" + this.precisio + ")";
	    else {
	      digits = "";
	    }
	    if ((this.tipus > sqlTypes.length) || (this.tipus < 0))
	      res = "Tipus : " + this.tipus + ";  Nom : " + this.nom;
	    else {
	      res = "Tipus : " + sqlTypes[(this.tipus - 1)] + digits + "; Nom : " + this.nom;
	    }
	    return res;
	  }*/
	  
	  public Object getColumnaInfoFromResultSet (ResultSet localResultSet) throws Exception {
		  
		   String nomColumna = localResultSet.getString(METADADA_COLUMN_NAME_INDEX);
		   int tipusDada = localResultSet.getInt(METADADA_COLUMN_DATATYPE_INDEX);
		   String nomTipusDada = localResultSet.getString(METADADA_COLUMN_TYPENAME_INDEX);
		   int tamanyDada=localResultSet.getInt(METADADA_COLUMN_SIZE_INDEX);
		   int precisioDada = localResultSet.getInt(METADADA_COLUMN_DECIMALDIGITS_INDEX);
		   boolean isNullable=localResultSet.getBoolean(METADADA_COLUMN_ISNULLABLE_INDEX);
		   boolean isAutoincremental= localResultSet.getBoolean(METADADA_COLUMN_ISAUTOINCREMENT_INDEX);
		   
		   GeneradorColumnaBDInfoImpl localColumnData = (GeneradorColumnaBDInfoImpl)this.getClass().newInstance();
		   localColumnData.nom=nomColumna;
	       localColumnData.tipus=tipusDada;
	       localColumnData.nomTipus=nomTipusDada;
	       localColumnData.tamany=tamanyDada;
	       localColumnData.precisio=precisioDada;
	       localColumnData.nullable=isNullable;
	       localColumnData.autoincremental=isAutoincremental;
	       
	       return localColumnData;
	  }
	  
	  
	  
	  
	  public GeneradorColumnaBDInfoImpl(String nom, int tipusOrig, int precisio)
	  {
		  this.nom = nom;
		  this.tipus = tipusOrig;
		  this.precisio = precisio;

		  switch (this.tipus)
		  {
		  	case -1:
			  this.tipus = 22;
			  break;
		    case -2:
		      this.tipus = 18;
		      break;
		    case -3:
		      this.tipus = 19;
	
		      break;
		    case -4:
		      this.tipus = 19;
		      break;
		    case -5:
		      this.tipus = 3;
		      break;
		    case -6:
		      this.tipus = 2;
		      break;
		    case -7:
		      this.tipus = 16;
		      break;
		    case 1111:
		      this.tipus = 13;
		      break;
		    case 91:
		      this.tipus = 11;
		      break;
		    case 92:
		      this.tipus = 14;
		      break;
		    case 93:
		      this.tipus = 14;
		      break;
		    }

		  	if ((this.tipus < 1) || (this.tipus > 24))
		  	{
		  		String msgWarning="Error - La columna : " + this.nom + " no disposa d'un tipus reconegut. Valor : " + this.tipus + ". Se li assigna el valor per defecte (String)!";
		  		//log.log(Level.DEBUG, msgWarning);
		  		this.tipus = 12;
		  	}
	  }
	  
	  public String getTipusJava()
	  {
	    String tipusJava = null;

	    switch (this.tipus)
	    {
	    	case 1:
		    case 12:
		    case 13:
		    case 22:
		    	tipusJava = "String";
		      break;
		    case 2:
		    	tipusJava = "byte";
		      break;
		    case 3:
		    	tipusJava = "long";
		      break;
		    case 4:
		    	tipusJava = "int";
		      break;
		    case 5:
		    	tipusJava = "short";
		      break;
		    case 6:
		    case 8:
		    	tipusJava = "double";
		      break;
		    case 9:
		    case 10:
		    	tipusJava = "java.math.BigDecimal";
		      break;
		    case 7:
		    	tipusJava = "float";
		      break;
		    case 11:
		    	tipusJava = "java.util.Date";
	
		      break;
		    case 14:
		    	tipusJava = "Timestamp";
		      break;
		    case 15:
		    	tipusJava = "Time";
		      break;
		    case 16:
		    	tipusJava = "boolean";
		      break;
		    case 17:
		    case 18:
		    case 19:
		    	tipusJava = "byte[]";
		      break;
		    case 20:
		    	tipusJava = "null";
		      break;
		    case 21:
		    default:
		    	tipusJava = "String";
		    	String msg="Error- el tipus: " + this.tipus + " es desconegut. Es retorna el tipus per defecte (String)";
		    }										

	    return tipusJava;
	  }
	
}
