package edu.uoc.pfc.mena.db.utilities.provider.hsqldb;

import java.sql.ResultSet;
import java.util.ArrayList;

import org.apache.log4j.Logger;

import edu.uoc.pfc.mena.db.core.constants.Constants;
import edu.uoc.pfc.mena.db.core.exception.BDException;
import edu.uoc.pfc.mena.db.utilities.GeneradorColumnaBDInfo;
import edu.uoc.pfc.mena.db.utilities.GeneradorTaulaBDInfoImpl;

public class TaulaBDInfoHsqldbImpl extends GeneradorTaulaBDInfoImpl {
	       	   
	private static Logger log = Logger.getLogger(TaulaBDInfoHsqldbImpl.class.getName());
	
	public TaulaBDInfoHsqldbImpl() throws Exception {
		super();
	}
	
	
	 public void addColumnesInfo() throws BDException {
		 ResultSet localResultSet = null;
	    try{
		    setInfoColumnes(new ArrayList<GeneradorColumnaBDInfo>());
	
		    localResultSet= this.getMetadadaBD().getColumns(null, LIKE_SYMBOL, this.getNomTaula(), LIKE_SYMBOL);
		    while (localResultSet.next())
		    {
		      String str5 = localResultSet.getString(4);
		      int i, j;
		      GeneradorColumnaBDInfo localColumnData= null;
		      i = localResultSet.getInt(5);
		      j = localResultSet.getInt(7);
		      if (i == 2){
		    	  i = 3;
		      }
		      
		      localColumnData = new ColumnaBDInfoHsqlImpl(str5, i, j);  
		      log.debug(">>>>>>>>>>>>>> Info columna [ " + localColumnData+ "]");    
		      
		      this.getInfoColumnes().add(localColumnData);
		    }
		    
		    this.setNumCamps(this.getInfoColumnes().size());
		 }catch(Exception e){
			 throw new BDException (Constants.GET_METADATA_ERROR_CODE, Constants.GET_METADATA_ERROR_MSG,e );
		 }
	 finally{ 
		 try{localResultSet.close();}catch(Exception ignored){}
	 }

	  }
	 
	 public String getHasPK(){
		 return null;
	 }


	@Override
	public String getTipusJava() throws Exception {
		// TODO Auto-generated method stub
		return null;
	}


	@Override
	public void addPrimaryKey() throws BDException {
		// TODO Auto-generated method stub
		
	}
	 
	
}
