package edu.uoc.pfc.mena.db.utilities.provider.mysql;

import edu.uoc.pfc.mena.db.utilities.GeneradorColumnaBDInfoImpl;

/**
 * Classe per especificar els mappings de tipus Java i MySQL. 
 * @author Jammy
 *
 */
public class ColumnaBDInfoMysqlImpl extends GeneradorColumnaBDInfoImpl {

	public ColumnaBDInfoMysqlImpl() {
		super();

	}
	
	public ColumnaBDInfoMysqlImpl(String nom, int tipus, int precisio) {
		super(nom, tipus, precisio);
	}
	
	public String getTipusJava() {
		
		try {
			if ("BINARY".equals (this.getNomTipus()) || "VARBINARY".equals (this.getNomTipus()) || "TINYBLOB".equals (this.getNomTipus()) || "MEDIUMBLOB".equals (this.getNomTipus()) || "LONGBLOB".equals (this.getNomTipus()) ){
				return JAVA_TYPE_BYTE_ARRAY;
			} else if ("SMALLINT".equals (this.getNomTipus()) || "MEDIUMINT".equals (this.getNomTipus()) || "INT".equals (this.getNomTipus()) || "INTEGER".equals (this.getNomTipus()) ){
					return JAVA_TYPE_INTEGER;
			} else if("INTEGER UNSIGNED".equals (this.getNomTipus()) || "BIGINT".equals (this.getNomTipus())){
				return JAVA_TYPE_LONG;
			} else if("FLOAT".equals (this.getNomTipus())){
				return JAVA_TYPE_FLOAT;
			} else if("DOUBLE".equals (this.getNomTipus())){
				return JAVA_TYPE_DOUBLE;
			} else if("DATETIME".equals (this.getNomTipus()) || "TIMESTAMP".equals (this.getNomTipus()) ) {
				return JAVA_TYPE_TIMESTAMP;
			} else if("DECIMAL".equals (this.getNomTipus()) || "TIMESTAMP".equals (this.getNomTipus()) ) {
				return JAVA_TYPE_DECIMAL;
			} else if("BIT".equals (this.getNomTipus())|| ("TINYINT".equals (this.getNomTipus()))) {
				return JAVA_TYPE_BOOLEAN;
			} else { return JAVA_TYPE_STRING;}	
		}catch(Exception e){
			return JAVA_TYPE_STRING;
		}
	}
		
}
