package edu.uoc.pfc.mena.db.utilities.provider.mysql;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;

import org.apache.log4j.Logger;

import edu.uoc.pfc.mena.db.core.constants.Constants;
import edu.uoc.pfc.mena.db.core.exception.BDException;
import edu.uoc.pfc.mena.db.utilities.GeneradorColumnaBDInfo;
import edu.uoc.pfc.mena.db.utilities.GeneradorTaulaBDInfoImpl;

/**
 * Mappings entre la taula sql i la classe Java.
 * @author Jammy
 *
 */
public class TaulaBDInfoMysqlImpl extends GeneradorTaulaBDInfoImpl{
		   
	private static Logger log = Logger.getLogger(TaulaBDInfoMysqlImpl.class.getName());
	
	public TaulaBDInfoMysqlImpl() throws Exception {
		super();
	}
	
	
	 public void addPrimaryKey() throws BDException {
		 this.setInfoClaus (new ArrayList<String>());
		 ResultSet localResultSet = null;
	    try
	    {
	      localResultSet = this.getMetadadaBD().getPrimaryKeys(null, LIKE_SYMBOL, this.getNomTaula());
	      int numColumnes=0;
	      while (localResultSet.next())
	      {
	    	  String columna = localResultSet.getString(METADADA_COLUMN_NAME_INDEX);
	    	  this.getInfoClaus().add(columna);
	    	  numColumnes++;
	      }
	      
	      if (numColumnes==0){
	    	  throw new BDException (Constants.PK_ERROR_CODE, Constants.UNDEFINED_PK_ERROR_MSG);
	      }
	    }
	    catch (SQLException localSQLException)
	    {
	      System.err.println("Error obtenint les claus " +  this.getNomTaula());
	      System.err.println(localSQLException);
	      throw new BDException (Constants.PK_ERROR_CODE,Constants.PK_ERROR_MSG + localSQLException.getMessage(),localSQLException );
	    }
	    finally{
	    	try{localResultSet.close();}catch(Exception ignored){}
	    }

	  }
	
	 public void addColumnesInfo() throws BDException {

	    this.setInfoColumnes (new ArrayList<GeneradorColumnaBDInfo>());
	    ResultSet localResultSet = null;
	    try
	    {
	    	localResultSet = this.getMetadadaBD().getColumns(null, LIKE_SYMBOL, this.getNomTaula(), LIKE_SYMBOL);
	 	    ColumnaBDInfoMysqlImpl localColumnData = null;
	    	while (localResultSet.next())
	    	{    	
	    		String nomTaula = localResultSet.getString(METADADA_TABLENAME_INDEX);
	    		if (!this.getNomTaula().equalsIgnoreCase(nomTaula)){
	    			throw new BDException(Constants.TABLE_MAPPING_ERROR_CODE, Constants.TABLE_MAPPING_ERROR_MSG);
	    		}	      
	    
	    		localColumnData = (ColumnaBDInfoMysqlImpl) new ColumnaBDInfoMysqlImpl().getColumnaInfoFromResultSet(localResultSet);
	    		this.getInfoColumnes().add(localColumnData);
	    		log.debug(">>>>>>>>>>>>>> Info columna [ " + localColumnData+ "]");  
	    	}
	     
	        
	    } catch (Exception e) {
	    	log.error(e.getMessage()); 
			throw new BDException (Constants.GET_METADATA_ERROR_CODE, Constants.GET_METADATA_ERROR_MSG,e );
		}
	    finally{ 
	    	try{localResultSet.close();}catch(Exception ignored){}
	    }
	    this.setNumCamps(this.getInfoColumnes().size());
	    
	  }
	 
	 public String getHasPK(){
		 return null;
	 }


	@Override
	public String getTipusJava() throws Exception {
		// TODO Auto-generated method stub
		return null;
	}
	
}
