package test.main;

import java.math.BigDecimal;

import test.main.exemple.beans.Oferta;
import edu.uoc.pfc.mena.db.core.exception.BDException;
import edu.uoc.pfc.mena.db.core.session.Sessio;
import edu.uoc.pfc.mena.db.core.session.factory.SessioFactory;

public class TestFwBD {

	/**
	 * @param args
	 * @throws BDException 
	 */
	public static void main(String[] args) throws BDException {
		
		Sessio sessio= null;
		try {
			sessio= SessioFactory.getInstance().newSessio();
			sessio.newTransaccio(false);
		
			Oferta volAustralia= new Oferta();
			volAustralia.setCodi("VO-AU-8");
			volAustralia.setDescripcio("Vol d'anada i tornada a Sydney a l'agost.");
			volAustralia.setPreu(new BigDecimal(1534.65));
			sessio.insert(volAustralia);
			
			Oferta hotelSydney= new Oferta();
			hotelSydney.setCodi("HO-SYD-8");
			StringBuffer desc=new StringBuffer("7 nits a l'hotel 4* Rydges (a Cronulla Beach)");
			desc.append(" en habitaci doble amb vistes al mar en rgim de MP.");
			hotelSydney.setDescripcio(desc.toString());
			hotelSydney.setPreu(new BigDecimal(825.99));
			sessio.insert(hotelSydney);
			
			sessio.getTransaccio().commit();
			
		}catch(Exception e){
			e.printStackTrace();
			sessio.getTransaccio().rollback();
		}
		finally{
			sessio.tancaTransaccio();
		}
	}

	
	

}
