CREATE TABLE CLIENT
(
	id SMALLINT NOT NULL AUTO_INCREMENT,
	dni varchar(9) NOT NULL,
	nom varchar(30),
	cognom1 varchar(30),
	cognom2 varchar(30),
	correu varchar (100),
	PRIMARY KEY (id),
	UNIQUE (dni)
);

CREATE TABLE USUARI
(
	id SMALLINT NOT NULL AUTO_INCREMENT,
	usuari varchar(50) NOT NULL,
	contrasenya varchar(50),
	PRIMARY KEY (id),
	UNIQUE (usuari)
);

CREATE TABLE DESTI
(
	id SMALLINT NOT NULL AUTO_INCREMENT,
	localitat varchar (100) NOT NULL,
	pais varchar (50),
	PRIMARY KEY (id),
	UNIQUE (localitat)
);

CREATE TABLE TIPUS_VIATGE
(
	id SMALLINT NOT NULL AUTO_INCREMENT,
	codi varchar(10) NOT NULL,
	nom varchar (50),
	PRIMARY KEY (id),
	UNIQUE (codi)
);

CREATE TABLE OFERTA
(
	id SMALLINT NOT NULL AUTO_INCREMENT,
	codi varchar(10) NOT NULL,
	descripcio varchar(255),
	-- detall blob,
	preu DECIMAL(7,2) NOT NULL,
	places SMALLINT NOT NULL,
	id_desti INT NOT NULL REFERENCES DESTI(id),
	id_tipus_viatge INT REFERENCES TIPUS_VIATGE(id),
	PRIMARY KEY (id),
	UNIQUE (codi)
);

CREATE TABLE INSCRIPCIO
(
	id SMALLINT NOT NULL AUTO_INCREMENT,
	data TIMESTAMP NOT NULL,
	id_oferta INT NOT NULL REFERENCES OFERTA(id),
	id_client INT NOT NULL REFERENCES CLIENT(id),
	PRIMARY KEY (id)
);


insert into desti (localitat,pais) values ('Nova York', 'USA');
insert into desti (localitat,pais) values ('Ribera Maya', 'Mexic');
insert into desti (localitat,pais) values ('California', 'USA');
insert into desti (localitat,pais) values ('Sydney', 'Australia');
insert into desti (localitat,pais) values ('Arequipa', 'Peru');

insert into tipus_viatge(codi, nom) values ('RELAX','Descans al carib');
insert into tipus_viatge(codi, nom) values ('CULTURA','Cultura');
insert into tipus_viatge(codi, nom) values ('MULTIPLE','Inclou el subgrup de la resta de tipus de viatges');


