package edu.uoc.pfc.mena.webapp.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import edu.uoc.pfc.mena.webapp.constants.ActionConstants;
import edu.uoc.pfc.mena.webapp.form.OfertesForm;
import edu.uoc.pfc.mena.webapp.pojo.OfertaTO;


public class GestionarOfertaAction extends GlobalAction  {
  
  private static final Logger log = Logger.getLogger( GestionarOfertaAction.class );
 

  public ActionForward doExecute(ActionMapping mapping, ActionForm form, HttpServletRequest req, HttpServletResponse res) throws Exception{

	  try{
		  
		  OfertesForm oForm= (OfertesForm) form;		  
		  if (oForm.getIdAccio()==null || "".equals(oForm.getIdAccio())){
			  OfertaTO o = new OfertaTO();
			  o.getOferta().setId(-1);
			  req.setAttribute( ActionConstants.HTTP_REQUEST_ATTRIBUTE_OFERTA,  o);
			  
			  // Obtenim tots els destins i tipus de viatges disponibles
			  super.addDestins(req);
			  super.addTipusViatges(req);
			  
			  return mapping.findForward( ActionConstants.MAPPING_AFEGIR );
		  } else if ("filter".equals(oForm.getIdAccio())){
			  // llistar
			  CercarOfertesAction coa= new CercarOfertesAction();
			  coa.execute(mapping, oForm, req, res);
			  if (req.getParameter("isFiltreLoad")!=null && "true".equals(req.getParameter("isFiltreLoad"))){
				  req.setAttribute( ActionConstants.HTTP_REQUEST_ATTRIBUTE_FILTRE_LOADED, true );
			  }
		  } else if ("resetFilter".equals(oForm.getIdAccio())){
			  // llistar
			  CercarOfertesAction coa= new CercarOfertesAction();
			  coa.execute(mapping, new OfertesForm(), req, res);
			  req.setAttribute( ActionConstants.HTTP_REQUEST_ATTRIBUTE_FILTRE_LOADED, false );
		  } else if ("view".equals(oForm.getIdAccio())){
			  // mostrar
			  VisualitzarOfertaAction voa= new VisualitzarOfertaAction();
			  voa.execute(mapping, oForm, req, res);
			  
			  // Obtenim tots els destins i tipus de viatges disponibles
			  super.addDestins(req);
			  super.addTipusViatges(req);
			  
			  return mapping.findForward( ActionConstants.MAPPING_DETALL );
		  } else if ("del".equals(oForm.getIdAccio())){
			  // eliminar
			  EliminarOfertaAction eoa= new EliminarOfertaAction();
			  eoa.execute(mapping, oForm, req, res);
		  }  		  

	  }catch(Exception e){
	      log.error( "S'ha produit un error carregant la pagina : "+e.getMessage() );
	      throw e;
	  }
	  
	  return mapping.findForward( ActionConstants.MAPPING_LLISTAT );
  }

}
