package edu.uoc.pfc.mena.webapp.action;

import java.util.ArrayList;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import edu.uoc.pfc.mena.db.core.exception.BDException;
import edu.uoc.pfc.mena.webapp.beans.Usuari;
import edu.uoc.pfc.mena.webapp.constants.ActionConstants;
import edu.uoc.pfc.mena.webapp.constants.AgenciaConstants;
import edu.uoc.pfc.mena.webapp.exception.AgenciaException;
import edu.uoc.pfc.mena.webapp.form.LoginForm;
import edu.uoc.pfc.mena.webapp.form.OfertesForm;
import edu.uoc.pfc.mena.webapp.services.UsuarisServei;
import edu.uoc.pfc.mena.webapp.spring.AgenciaContext;
import edu.uoc.pfc.mena.webapp.utils.MessageResourcesUtil;

public class LoginAction extends CercarOfertesAction {

	  private static final Logger log = Logger.getLogger( LoginAction.class );
	
	  public ActionForward doExecute(ActionMapping mapping, ActionForm form, HttpServletRequest req, HttpServletResponse res) throws Exception{

		  this.errorMessages = new ArrayList<String>();
		  
		  try{
			  LoginForm loginForm= (LoginForm) form; 	
			  this.checkInformat(loginForm.getUsuari(), AgenciaConstants.USUARI_REQUIRED, req.getLocale());
			  this.checkInformat(loginForm.getContrasenya(), AgenciaConstants.CONTRASENYA_REQUIRED, req.getLocale());
			  
			  if (this.errorMessages.size()>0)
			  {
				  req.setAttribute( ActionConstants.HTTP_REQUEST_ATTRIBUTE_ERROR, this.getMissatgeError());
				  return mapping.findForward( ActionConstants.MAPPING_LOGIN); 
			  } 
			  else
			  {
				  UsuarisServei usuariServei=AgenciaContext.getInstance().getUsuarisServei();
				  Usuari usuari=usuariServei.login(loginForm.getUsuari(), loginForm.getContrasenya());
				  if (usuari!=null) {
					  req.getSession().setAttribute( ActionConstants.HTTP_REQUEST_ATTRIBUTE_USER_LOGIN, usuari );
					  // Fem la cerca de les ofertes
					  return super.doExecute(mapping, new OfertesForm() , req, res);
				  }
			  }
		  }catch(Exception e){
			  gestionarError(req, e);
			  return mapping.findForward( ActionConstants.MAPPING_LOGIN);
		  }
		  
		  return mapping.findForward( ActionConstants.MAPPING_LOGIN );

	  }
}
