package edu.uoc.pfc.mena.webapp.action;

import java.util.ArrayList;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import edu.uoc.pfc.mena.webapp.constants.ActionConstants;
import edu.uoc.pfc.mena.webapp.pojo.OfertaTO;
import edu.uoc.pfc.mena.webapp.services.OfertesServei;
import edu.uoc.pfc.mena.webapp.spring.AgenciaContext;


public class ModificarOfertaAction extends CercarOfertesAction {
  
  private static final Logger log = Logger.getLogger( ModificarOfertaAction.class );
 

  public ActionForward doExecute(ActionMapping mapping, ActionForm form, HttpServletRequest req, HttpServletResponse res) throws Exception{
	  this.errorMessages = new ArrayList<String>();
	  try{
		  OfertaTO oferta= getOferta(req);
		  req.setAttribute( ActionConstants.HTTP_REQUEST_ATTRIBUTE_OFERTA, oferta );
		  
		  if (this.errorMessages.size()>0)
		  {
			  req.setAttribute( ActionConstants.HTTP_REQUEST_ATTRIBUTE_ERROR, this.getMissatgeError());
			  super.addDestins(req);
			  super.addTipusViatges(req);
			  return mapping.findForward( ActionConstants.MAPPING_ERROR); 
		  } 
		  else
		  {
			  OfertesServei ofertesServei=AgenciaContext.getInstance().getOfertesServei();
			  ofertesServei.modificarOferta(oferta);
			  
			 // Obtenim la llista
			 super.doExecute(mapping, form, req, res);
			 return mapping.findForward( ActionConstants.MAPPING_LLISTAT );
		  } 		
		  
	  }catch(Exception e){
		  gestionarError(req, e);
		  return mapping.findForward( ActionConstants.MAPPING_ERROR);
	  }
	  
  }
  
 
}
