package edu.uoc.pfc.mena.webapp.action;

import java.util.ArrayList;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import edu.uoc.pfc.mena.webapp.constants.ActionConstants;
import edu.uoc.pfc.mena.webapp.constants.AgenciaConstants;
import edu.uoc.pfc.mena.webapp.form.OfertesForm;
import edu.uoc.pfc.mena.webapp.form.ReservaForm;
import edu.uoc.pfc.mena.webapp.pojo.OfertaTO;
import edu.uoc.pfc.mena.webapp.services.OfertesServei;
import edu.uoc.pfc.mena.webapp.spring.AgenciaContext;

public class ReservarOfertaAction extends CercarOfertesAction {

	  private static final Logger log = Logger.getLogger( ReservarOfertaAction.class );
	
	  public ActionForward doExecute(ActionMapping mapping, ActionForm form, HttpServletRequest req, HttpServletResponse res) throws Exception{

		  OfertesServei ofertesServei=AgenciaContext.getInstance().getOfertesServei();
		  
		  this.errorMessages= new ArrayList<String>();
		  ReservaForm reservaForm= (ReservaForm) form; 	
		  
		  super.checkInformat(reservaForm.getCodi(), AgenciaConstants.RESERVA_NIF_REQUIRED, req.getLocale());
		  super.checkInformat(reservaForm.getCorreu(), AgenciaConstants.RESERVA_CORREU_REQUIRED, req.getLocale());
		  
		  if (this.errorMessages.size()>0)
		  {
			  req.setAttribute( ActionConstants.HTTP_REQUEST_ATTRIBUTE_ERROR, this.getMissatgeError());
			  
			  OfertaTO oferta=ofertesServei.cercaOfertaById(Integer.parseInt(req.getParameter("oferta_id")));
			  req.setAttribute( ActionConstants.HTTP_REQUEST_ATTRIBUTE_OFERTA, oferta );
			  
			  return mapping.findForward( ActionConstants.MAPPING_ERROR); 
		  } 
		  else
		  {  
			  ofertesServei.inscriureClient(reservaForm.getClient(), Integer.parseInt(req.getParameter("oferta_id")));
		
			  super.doExecute(mapping, new OfertesForm(), req, res);
			  
			  // Afegim el misssatge a la pantalla
			  req.setAttribute( ActionConstants.HTTP_REQUEST_ATTRIBUTE_ESTAT_OPERACIO, ActionConstants.MAPPING_OK.toUpperCase() );
		  }
		  return mapping.findForward( ActionConstants.MAPPING_OK );

	  }
}
