package edu.uoc.pfc.mena.webapp.dao.impl;

import java.util.ArrayList;
import java.util.List;

import edu.uoc.pfc.mena.db.core.exception.BDException;
import edu.uoc.pfc.mena.webapp.beans.Oferta;
import edu.uoc.pfc.mena.webapp.constants.AgenciaConstants;
import edu.uoc.pfc.mena.webapp.dao.AbstractGenericDAO;
import edu.uoc.pfc.mena.webapp.dao.OfertaDAO;
import edu.uoc.pfc.mena.webapp.filter.OfertesFilter;
import edu.uoc.pfc.mena.webapp.pojo.OfertaTO;
import edu.uoc.pfc.mena.webapp.query.LlistatOfertaQueryBean;

public class OfertaDAOImpl extends AbstractGenericDAO<Oferta> implements OfertaDAO, AgenciaConstants {
  
	@Override
	public int afegirOferta(OfertaTO o) throws BDException {
		return super.insert(o.toBean(), true);
	}
	
	@Override
	public void modificarOferta(OfertaTO o) throws BDException {
		super.update(o.toBean(), true);
	}
	
	@Override
	public void eliminarOferta(OfertaTO o) throws BDException {
		super.delete(o.toBean(), true);
		
	}
	
	@Override
	public OfertaTO cercaOfertaById(int id) throws BDException, InstantiationException, IllegalAccessException {
		OfertesFilter filtre= new OfertesFilter();
		filtre.setId(id);
		List<OfertaTO> ofertes= this.cercaOfertes(filtre);
		return ofertes.get(0);
	}
	
	@Override
	public List<OfertaTO> cercaOfertes(OfertesFilter filtre) throws BDException, InstantiationException, IllegalAccessException {
		List<Object> ofertes=(List<Object>)super.executeQuery(filtre.getSQL(), LlistatOfertaQueryBean.class); 
		List<OfertaTO> ofertesTO= new ArrayList<OfertaTO>();
		for (Object o : ofertes){
			ofertesTO.add(((LlistatOfertaQueryBean)o).getOfertaTO());
		}
		
		return ofertesTO;
	}

}
