package edu.uoc.pfc.mena.webapp.dao.impl;

import java.util.List;

import org.apache.log4j.Logger;

import edu.uoc.pfc.mena.db.core.exception.BDException;
import edu.uoc.pfc.mena.webapp.beans.Usuari;
import edu.uoc.pfc.mena.webapp.constants.AgenciaConstants;
import edu.uoc.pfc.mena.webapp.dao.AbstractGenericDAO;
import edu.uoc.pfc.mena.webapp.dao.UsuariDAO;
import edu.uoc.pfc.mena.webapp.exception.AgenciaException;
import edu.uoc.pfc.mena.webapp.services.provider.PropertiesProviderService;

public class UsuariDAOImpl extends AbstractGenericDAO<Usuari> implements UsuariDAO, AgenciaConstants {

	private static final Logger log = Logger.getLogger( UsuariDAOImpl.class );
	
	private PropertiesProviderService languageProperties;
	
	public PropertiesProviderService getLanguageProperties() {
		return languageProperties;
	}

	public void setLanguageProperties(PropertiesProviderService languageProperties) {
		this.languageProperties = languageProperties;
	}

	@Override
	public int afegirUsuari(Usuari u) throws BDException {
		return super.insert(u, true);
	}

	@Override
	public Usuari cercaUsuariById(int id) throws BDException {
		Usuari u=new Usuari();
		u.setId(id);
		return super.findById(u);
	}

	@Override
	public Usuari loginUsuari(String codiUsuari, String contrasenya) throws BDException, AgenciaException {
		Usuari dadesUsuari= null;

			List<Usuari> usuaris=super.find("SELECT * FROM USUARI WHERE USUARI='"+codiUsuari+"'", new Usuari());
			if (usuaris==null || usuaris.size()==0){
				throw new AgenciaException(this.languageProperties.getProperty(ERROR_MSG_LOGIN_USUARI));
			}
			dadesUsuari=usuaris.get(0); // Obtenim el primer		
			if (!(dadesUsuari.getContrasenya()==null || "".equals(dadesUsuari.getContrasenya()) || contrasenya.equalsIgnoreCase(dadesUsuari.getContrasenya()))){
				throw new AgenciaException(this.languageProperties.getProperty(ERROR_MSG_LOGIN_CONTRANSENYA));
			}

		return dadesUsuari;
	}

}
