package edu.uoc.pfc.mena.webapp.filter;


public class OfertesFilter extends GenericFilter {
	 
  	private Integer id;	  	
  	private String cerca;
	private Integer preuMinim;
	private Integer preuMaxim;
	private String desti;
	private Integer tipus; 
	private String infoFiltre;

	public OfertesFilter() {
	    super();
	}
		
	public Integer getId() {
		return id;
	}
	public void setId(Integer id) {
		this.id = id;
	}
	
	public Integer getTipus() {
		return tipus;
	}
	public void setTipus(Integer tipus) {
		this.tipus = tipus;
	}
	public String getCerca() {
		return cerca;
	}
	public void setCerca(String cerca) {
		this.cerca = cerca;
	}
	public Integer getPreuMaxim() {
		return preuMaxim;
	}

	public void setPreuMaxim(Integer preuMaxim) {
		this.preuMaxim = preuMaxim;
	}
	public Integer getPreuMinim() {
		return preuMinim;
	}

	public void setPreuMinim(Integer preuMinim) {
		this.preuMinim = preuMinim;
	}
	public String getDesti() {
		return desti;
	}
	public void setDesti(String desti) {
		this.desti = desti;
	}


	public String getSQL() {
		boolean first=false;
		StringBuilder info= new StringBuilder();
		StringBuilder sql= new StringBuilder("SELECT o.*,d.id as idDesti, d.localitat, d.pais, t.ID AS idTipusViatge, t.CODI AS codiTipusViatge, t.NOM AS nomTipusViatge, (select count(i.id) FROM INSCRIPCIO i WHERE i.ID_OFERTA=o.ID )AS numInscripcions from OFERTA o, DESTI d, TIPUS_VIATGE t WHERE t.ID=o.ID_TIPUS_VIATGE AND d.ID=o.ID_DESTI ");
		
		if (this.getId()!=null && this.getId().intValue()>0){
			sql.append(" AND o.ID="+this.getId());
		}
		
		if (this.getTipus()!=null && this.getTipus().intValue()>0){
			sql.append(" AND t.ID="+this.getTipus());
			info.append(" tipus de viatge");
			first=true;
		}
		
		
		if (this.getCerca()!=null && !"".equals(this.getCerca())) {
			sql.append(" AND (o.CODI LIKE '%"+super.escapeString(this.getCerca())+ "%' OR o.DESCRIPCIO LIKE '%"+super.escapeString(this.getCerca())+"%')");
			if (first){info.append(",");}else{first=true;}
			info.append(" codi o descripcio d'oferta");
		}
		
		if (this.getDesti()!=null && !"".equals(this.getDesti())) {
			sql.append(" AND (d.LOCALITAT LIKE '%"+super.escapeString(this.getDesti())+ "%' OR d.PAIS LIKE '%"+super.escapeString(this.getDesti())+ "%')");
			if (first){info.append(",");}else{first=true;}
			info.append(" desti");
		}
		
		if (this.getPreuMaxim()!=null && this.getPreuMaxim().intValue()>0){
			sql.append(" AND o.PREU <="+this.getPreuMaxim());
			if (first){info.append(",");}else{first=true;}
			info.append(" preu mxim");
		}
		if (this.getPreuMinim()!=null && this.getPreuMinim().intValue()>0){
			sql.append(" AND o.PREU >="+this.getPreuMinim());
			if (first){info.append(",");}else{first=true;}
			info.append(" preu mnim");
		}
		
		if (this.getSortField()!=null){
			sql.append(" ORDER BY  o.");
			sql.append(this.getSortField());
		} else {
			sql.append(" ORDER BY o.CODI");
		}
		
		if (this.getSortOrder()!=null){
			sql.append(" ");
			sql.append(this.getSortOrder());
		}
		
		this.infoFiltre=info.toString();
		return sql.toString();
	}
	
	public String getInfo(){
		return infoFiltre;
	}
	
	
}
