package edu.uoc.pfc.mena.webapp.query;

import edu.uoc.pfc.mena.db.core.annotations.Columna;
import edu.uoc.pfc.mena.db.core.annotations.Mapper;
import edu.uoc.pfc.mena.webapp.beans.Desti;
import edu.uoc.pfc.mena.webapp.beans.Oferta;
import edu.uoc.pfc.mena.webapp.beans.TipusViatge;
import edu.uoc.pfc.mena.webapp.pojo.OfertaTO;
/**
 * Classe per a fer el mapping amb el Resultset del llistat d'ofertes
 * @author Jammy
 *
 */
@Mapper
public class LlistatOfertaQueryBean {
	
	java.lang.Integer id; 
	java.lang.String codi; 
	java.lang.String descripcio; 
	java.math.BigDecimal preu; 
	java.lang.Integer places; 
	java.lang.Integer idDesti; 
	java.lang.Integer idTipusViatge;  
	java.lang.String codiTipusViatge; 
	java.lang.String nomTipusViatge;
	java.lang.String localitat; 
	java.lang.String pais;
	java.lang.Integer placesDisponibles;
	java.lang.Integer numInscripcions;
	
	
	@Columna (nom="id", tipus = "")
	public java.lang.Integer getId() {
		return id;
	}
	public void setId(java.lang.Integer id) {
		this.id = id;
	}
	@Columna (nom="codi", tipus = "")
	public java.lang.String getCodi() {
		return codi;
	}
	public void setCodi(java.lang.String codi) {
		this.codi = codi;
	}
	@Columna (nom="descripcio", tipus = "")
	public java.lang.String getDescripcio() {
		return descripcio;
	}
	public void setDescripcio(java.lang.String descripcio) {
		this.descripcio = descripcio;
	}
	@Columna (nom="preu", tipus = "")
	public java.math.BigDecimal getPreu() {
		return preu;
	}
	public void setPreu(java.math.BigDecimal preu) {
		this.preu = preu;
	}
	@Columna (nom="places", tipus = "")
	public java.lang.Integer getPlaces() {
		return places;
	}
	public void setPlaces(java.lang.Integer places) {
		this.places = places;
	}
	@Columna (nom="id_desti", tipus = "")
	public java.lang.Integer getIdDesti() {
		return idDesti;
	}
	
	public void setIdDesti(java.lang.Integer idDesti) {
		this.idDesti = idDesti;
	}
	@Columna (nom="localitat", tipus = "")
	public java.lang.String getLocalitat() {
		return localitat;
	}
	public void setLocalitat(java.lang.String localitat) {
		this.localitat = localitat;
	}
	
	@Columna (nom="pais", tipus = "")
	public java.lang.String getPais() {
		return pais;
	}
	public void setPais(java.lang.String pais) {
		this.pais = pais;
	}
	
	@Columna (nom="idTipusViatge", tipus = "")
	public java.lang.Integer getIdTipusViatge() {
		return idTipusViatge;
	}
	public void setIdTipusViatge(java.lang.Integer idTipusViatge) {
		this.idTipusViatge = idTipusViatge;
	}
	
	@Columna (nom="codiTipusViatge", tipus = "")
	public java.lang.String getCodiTipusViatge() {
		return codiTipusViatge;
	}
	public void setCodiTipusViatge(java.lang.String codiTipusViatge) {
		this.codiTipusViatge = codiTipusViatge;
	}
	
	@Columna (nom="nomTipusViatge", tipus = "")
	public java.lang.String getNomTipusViatge() {
		return nomTipusViatge;
	}
	public void setNomTipusViatge(java.lang.String nomTipusViatge) {
		this.nomTipusViatge = nomTipusViatge;
	}
	
	@Columna (nom="numInscripcions", tipus = "")
	public java.lang.Integer getNumInscripcions() {
		return numInscripcions;
	}

	public void setNumInscripcions(java.lang.Integer numInscripcions) {
		this.numInscripcions = numInscripcions;
	}
	
	public OfertaTO getOfertaTO(){
		OfertaTO oTo= new OfertaTO();
		
		Oferta o= new Oferta();
		o.setCodi(this.getCodi());
		o.setDescripcio(this.getDescripcio());
		o.setId(this.getId());
		o.setPlaces(this.getPlaces());
		o.setPreu(this.getPreu());
		o.setIdDesti(this.getIdDesti());
		o.setIdTipusViatge(this.getIdTipusViatge());
		oTo.setOferta(o);
		
		TipusViatge tv= new TipusViatge();
		tv.setId(this.getIdTipusViatge());
		tv.setCodi(this.getCodiTipusViatge());
		tv.setNom(this.getNomTipusViatge());
		oTo.setTipus(tv);
		
		Desti desti= new Desti();
		desti.setId(this.getIdDesti());
		desti.setLocalitat(this.getLocalitat());
		desti.setPais(this.getPais());
		oTo.setDesti(desti);
		
		oTo.setPlacesDisponibles(this.getPlaces().intValue()-this.getNumInscripcions().intValue());
		
		return oTo;
	}
	
}
