package edu.uoc.pfc.mena.webapp.services.impl;

import java.sql.Timestamp;
import java.util.List;

import org.apache.log4j.Logger;

import edu.uoc.pfc.mena.db.core.exception.BDException;
import edu.uoc.pfc.mena.webapp.beans.Client;
import edu.uoc.pfc.mena.webapp.beans.Inscripcio;
import edu.uoc.pfc.mena.webapp.dao.ClientDAO;
import edu.uoc.pfc.mena.webapp.dao.InscripcioDAO;
import edu.uoc.pfc.mena.webapp.dao.OfertaDAO;
import edu.uoc.pfc.mena.webapp.filter.OfertesFilter;
import edu.uoc.pfc.mena.webapp.pojo.OfertaTO;
import edu.uoc.pfc.mena.webapp.services.OfertesServei;
import edu.uoc.pfc.mena.webapp.services.provider.PropertiesProviderService;



public class OfertesServeiImpl implements OfertesServei {

  private static final Logger log = Logger.getLogger( OfertesServeiImpl.class );


  private PropertiesProviderService configProperties;
  private OfertaDAO ofertaDAO;
  private ClientDAO clientDAO;
  private InscripcioDAO inscripcioDAO;
  

	public PropertiesProviderService getConfigProperties() {
		return configProperties;
	}
	
	
	public void setConfigProperties(PropertiesProviderService configProperties) {
		this.configProperties = configProperties;
	}
	
	
	public OfertaDAO getOfertaDAO() {
		return ofertaDAO;
	}
	
	
	public void setOfertaDAO(OfertaDAO ofertaDAO) {
		this.ofertaDAO = ofertaDAO;
	}


	public void setInscripcioDAO(InscripcioDAO inscripcioDAO) {
		this.inscripcioDAO = inscripcioDAO;
	}


	public InscripcioDAO getInscripcioDAO() {
		return inscripcioDAO;
	}


	public void setClientDAO(ClientDAO clientDAO) {
		this.clientDAO = clientDAO;
	}


	public ClientDAO getClientDAO() {
		return clientDAO;
	}


	@Override
	public int afegirOferta(OfertaTO o) throws BDException{
		return ofertaDAO.afegirOferta(o);
	}


	public List<OfertaTO> cercarOfertes(OfertesFilter filtre) throws BDException, InstantiationException, IllegalAccessException {	
		return ofertaDAO.cercaOfertes(filtre);
	}
	
	public OfertaTO cercaOfertaById(Integer id) throws BDException, InstantiationException, IllegalAccessException {	
		return ofertaDAO.cercaOfertaById(id);
	}


	@Override
	public void modificarOferta(OfertaTO o) throws BDException {
		ofertaDAO.modificarOferta(o);
	}


	@Override
	public void eliminarOferta(OfertaTO o) throws BDException {
		ofertaDAO.eliminarOferta(o);
		
	}


	@Override
	public void inscriureClient(Client c, Integer idOferta) throws BDException {
		
		// Afegir les dades del client a BD
		Integer idClient=clientDAO.afegirClientByCodi(c);
		
		// Fer el insert a la taula inscripcions
		Inscripcio i= new Inscripcio();
		i.setData(new Timestamp (System.currentTimeMillis()));
		i.setIdClient(idClient);
		i.setIdOferta(idOferta);
		inscripcioDAO.afegirInscripcio(i);
	}
	
}