package edu.uoc.pfc.mena.webapp.services.provider.impl;

import java.sql.Connection;
import java.sql.SQLException;

import javax.sql.DataSource;

import org.apache.log4j.Logger;

import edu.uoc.pfc.mena.db.core.exception.BDException;
import edu.uoc.pfc.mena.webapp.services.provider.DBConnectionProvider;


public class DBConnectionProviderImpl implements DBConnectionProvider {
  
  private static final Logger log = Logger.getLogger( DBConnectionProviderImpl.class ); 
  private DataSource datasource;

  /**
   * 
   */
  public DBConnectionProviderImpl() {
    super();
  }

  /**
   * @param dataSource
   */
  public DBConnectionProviderImpl(DataSource datasource) {
    super();
    this.datasource = datasource;
  }


  public Connection getConnection() throws BDException {
    try{
      return this.datasource.getConnection();
    }catch (SQLException e) {
      log.error( "S'ha produitt un error obtenint la connexio de BBDD", e );
      throw new BDException(888,"",e);
    }
  }// getConnection

  /**
   * @return the datasource
   */
  public DataSource getDatasource() {
    return datasource;
  }

  /**
   * @param datasource the datasource to set
   */
  public void setDatasource(DataSource datasource) {
    this.datasource = datasource;
  }


}// DBConnectionProviderImpl
