package edu.uoc.pfc.mena.webapp.servlet.listener;

import java.net.URL;

import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;

import org.apache.log4j.Logger;
import org.apache.log4j.xml.DOMConfigurator;

import edu.uoc.pfc.mena.webapp.spring.AgenciaContext;

public class ListenerStartup implements ServletContextListener {
	
	 private static Logger log;

	 private static final String LOG4J_CONFIG_FILE = "log4j.xml";
	
	public void contextInitialized (ServletContextEvent event)  
	{		
	
		try {		
			// inicialitzacio del logger
		    initLogger();
		    
		    log.info( "Iniciant context spring " );
		    AgenciaContext.getInstance();
		    
		    // Acces a la bbdd
	    
		    log.info("Contexte iniciat!");				    
		}catch(Exception e) {
			e.printStackTrace();
			log.error("Error inicialitzant el contexte: ", e);			
		}
		finally {

		}		
	  }

	public void contextDestroyed(ServletContextEvent arg0) {
		  log.info("Contexte destruit!");	
	}
	

	private void initLogger(){
	    URL logConfURL = Thread.currentThread().getContextClassLoader().getResource( LOG4J_CONFIG_FILE );
	    DOMConfigurator.configure(logConfURL);
	    log = Logger.getLogger( ListenerStartup.class );    
	}
}
