package edu.uoc.pfc.mena.webapp.spring;

import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

import edu.uoc.pfc.mena.webapp.services.DestinsServei;
import edu.uoc.pfc.mena.webapp.services.OfertesServei;
import edu.uoc.pfc.mena.webapp.services.TipusViatgesServei;
import edu.uoc.pfc.mena.webapp.services.UsuarisServei;
import edu.uoc.pfc.mena.webapp.services.provider.PropertiesProviderService;

public class AgenciaContext {

  private static final String CONFIG_PROPERTIES_SERVICE = "propertiesProviderService";

  private static final String OFERTES_SERVEI = "ofertesServei"; 
  private static final String USUARIS_SERVEI = "usuarisServei";
  private static final String DESTINS_SERVEI = "destinsServei";
  private static final String TIPUS_VIATGE_SERVEI = "tipusViatgesServei";
  private static final String AGENCIA_CONTEXT_LOCATION = "classpath:agencia-context.xml";

 
  private static AgenciaContext instance;

  private ApplicationContext springContext;


  public static synchronized AgenciaContext getInstance() {
    if( instance == null ){
      instance = new AgenciaContext();
      instance.init();
    }
    return instance;
  }

  /**
   * Obte el servei d'obtencio de properties del contexte spring
   * @return PropertiesProviderService
   */
  public PropertiesProviderService getConfigPropertiesProviderService(){
    return (PropertiesProviderService) this.springContext.getBean( CONFIG_PROPERTIES_SERVICE );
  }
  
  public OfertesServei getOfertesServei(){
    return (OfertesServei) this.springContext.getBean( OFERTES_SERVEI );
  }
  
  public UsuarisServei getUsuarisServei(){
	    return (UsuarisServei) this.springContext.getBean( USUARIS_SERVEI );
  }
  
  public DestinsServei getDestinsServei(){
	    return (DestinsServei) this.springContext.getBean( DESTINS_SERVEI );
  }
  
  public TipusViatgesServei getTipusViatgesServei(){
	    return (TipusViatgesServei) this.springContext.getBean( TIPUS_VIATGE_SERVEI );
  }
	  
  
  /**
   * Instancia el context utilitzant els fitxers on es declaren els beans
   */
  private void init() {
    this.springContext = new ClassPathXmlApplicationContext( AGENCIA_CONTEXT_LOCATION );
  }
}
