package edu.uoc.pfc.mena.webapp.utils;

import java.text.MessageFormat;
import java.util.Locale;
import java.util.MissingResourceException;
import java.util.ResourceBundle;

public class MessageResourcesUtil {
	
  public static final String DEFAULT_BUNDLE_NAME = "Language";
  
    
  public static String getDisplayString(String id, Locale locale){
    return getDisplayString( DEFAULT_BUNDLE_NAME, id, null, locale );
    
  }
  
  public static String getDisplayString(String id, Object params[], Locale locale){
    return getDisplayString( DEFAULT_BUNDLE_NAME, id, params, locale );
  }
  
  
  public static String getDisplayString(String bundleName, String id, Locale locale){
    return getDisplayString( bundleName, id, null, locale );
  }//getDisplayString 
  
  
	public static String getDisplayString(String bundleName, String id, Object params[], Locale locale)
	{
		String text = null;
		ResourceBundle bundle = ResourceBundle.getBundle(bundleName, locale);
		try
		{
			text = bundle.getString(id);
		}
		catch (MissingResourceException e)
		{
			text = "!! key " + id + " not found !!";
		}
		if (params != null)
		{
			MessageFormat mf = new MessageFormat(text, locale);
			text = mf.format(params, new StringBuffer(), null).toString();
		}
		
		return text;
		
	}//getDisplayString	
	
}//Utils
