package edu.uoc.pfc.mena.db.core.util;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import org.apache.commons.lang3.StringUtils;

public class Utils {

	
	/**
	 *	UTILITATS DE FITXERS  
	 */
	
	
	public static boolean deleteFolder(File folder) throws IOException{
				
		if(folder.exists()){
		        File[] files = folder.listFiles();
		        if(null!=files){
		            for(int i=0; i<files.length; i++) {
		                if(files[i].isDirectory()) {
		                	deleteFolder(files[i]);
		                }
		                else {
		                    files[i].delete();
		                }
		            }
		        }
		 }
		 return(folder.delete());
	}

	

	public static String getFolderBase(String basedir, String packageName){
		return  basedir + File.separator + packageToFile(packageName);
	}
	/**
	 * 
	 * @param basedir
	 * @param packageName
	 * @param fileName
	 * @return
	 * @throws IOException
	 */
	public static BufferedWriter createFile(File localFolder, String fileName) throws IOException{
		
	    try
	    {
	      if (!localFolder.exists())
	    	  localFolder.mkdirs();
	    }
	    catch (Exception localException)
	    {
	      localException.printStackTrace();
	    }
	    String str2 = localFolder.getAbsolutePath() + File.separator + fileName ;
	    return new BufferedWriter(new FileWriter(str2));	
	}
	
	  
	  
	  public static void print(BufferedWriter out, String paramString)
	    throws IOException
	  {
	      out.write(paramString);
	  }
	  
	  
	  public static String packageToFile(String packageName)
	  {
	    return replaceString(packageName, ".", File.separator);
	  }
	  
	  /**
	   *  UTILITATS D'STRING
	   */
	  
	  /**
	   * 
	   * @param value
	   * @return
	   */
	  public static String toCamelCase(String value){
		  return toCamelCase(value, true);
	  }
	
	  public static String toCamelCase(String value, boolean startWithLowerCase) {
			String[] strings = value.toLowerCase().split("_");
			for (int i = startWithLowerCase ? 1 : 0; i < strings.length; i++){
				strings[i] = StringUtils.capitalize(strings[i]);
			}
			String ret="";
			for (int i=0;i<strings.length;i++){
				ret=ret.concat(strings[i]);
			}
			return ret;
		}
	  
	  public static String replaceString(String paramString1, String paramString2, String paramString3)
	  {
	    if (paramString1 == null)
	      return null;
	    if ((paramString2 == null) || (paramString2.length() == 0))
	      return paramString1;
	    if (paramString3 == null)
	      paramString3 = "";
	    StringBuffer localStringBuffer = new StringBuffer(paramString1.length());
	    int i = 0;
	    for (int j = 0; i >= 0; j = i + paramString2.length())
	    {
	      i = paramString1.indexOf(paramString2, j);
	      if (i >= 0)
	      {
	        localStringBuffer.append(paramString1.substring(j, i));
	        localStringBuffer.append(paramString3);
	      }
	      else
	      {
	        localStringBuffer.append(paramString1.substring(j));
	      }
	    }
	    return localStringBuffer.toString();
	  }
	  
	  
	
}
